SystemOrganization addCategory: #'DAO-Satellite'!
SystemOrganization addCategory: #'DAO-Satellite-Web'!

WAComponent subclass: #SatelliteControlWebComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite-Web'!

SatelliteControlWebComponent subclass: #CommandRequestForm
	instanceVariableNames: 'commandRequest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite-Web'!

!CommandRequestForm methodsFor: 'model' stamp: 'EmilianoMenendez 10/21/2013 14:56'!
commandRequest
	^ commandRequest ifNil: [commandRequest := CommandRequest new].
	
! !

!CommandRequestForm methodsFor: 'rendering' stamp: 'EmilianoMenendez 10/22/2013 21:52'!
renderContentOn: html
	| form |
	
	form := html form.
	form class: 'pure-form-stacked'.
	form with: [
		html fieldSet: [ 
			html label: 'Subsystem'.
			html textInput
				callback: [ :value | self commandRequest subsystemId: value ];
				value: self commandRequest subsystemId.
			html label: 'Command'.
			html textInput
				callback: [ :value | self commandRequest commandId: value ];
				value: self commandRequest commandId.
			html submitButton
				callback: [ self answer: self commandRequest ];
				value: 'Send'.
		].
	].
! !

SatelliteControlWebComponent subclass: #SatelliteControlView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite-Web'!

SatelliteControlView subclass: #CommandRequestView
	instanceVariableNames: 'model bytes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite-Web'!

!CommandRequestView class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 16:12'!
model: aCommandRequestModel
	^ self new initializeWithModel: aCommandRequestModel.! !

!CommandRequestView methodsFor: 'initialization' stamp: 'EmilianoMenendez 10/22/2013 21:02'!
initializeWithModel: aCommandRequestModel
	super initialize.
	model := aCommandRequestModel.

! !

!CommandRequestView methodsFor: 'initialization' stamp: 'EmilianoMenendez 10/22/2013 17:23'!
model
	^ model
! !

!CommandRequestView methodsFor: 'rendering' stamp: 'EmilianoMenendez 10/22/2013 17:27'!
renderContentOn: html
	html label: 'Time: '.
	html text: model time printString.
	html break.
	html label: 'Subsystem: '.
	html text: model subsystem id.
	html break.
	html label: 'Command: '.
	html text: model commandId.
	html break.
	html label: 'Bytes: '.
	html text: bytes.
	html break.
! !

SatelliteControlView subclass: #CommandResponseView
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite-Web'!

!CommandResponseView class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 16:12'!
model: aCommandResponseModel
	^ self new initializeWithModel: aCommandResponseModel.! !

!CommandResponseView methodsFor: 'initialization' stamp: 'EmilianoMenendez 10/22/2013 16:12'!
initializeWithModel: aCommandResponseModel
	model := aCommandResponseModel! !

!CommandResponseView methodsFor: 'model' stamp: 'EmilianoMenendez 10/22/2013 16:58'!
model
	^ model! !

!CommandResponseView methodsFor: 'rendering' stamp: 'EmilianoMenendez 10/22/2013 16:58'!
renderContentOn: html
	html label: 'Time: '.
	html text: self model time printString.
	html break.
	html label: 'Data: '.
	html break.
	model data do: [ :data |
		html text: data key, ':', data value printString.
		html break.
	].
! !

SatelliteControlView subclass: #ControllerLogEntryView
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite-Web'!

!ControllerLogEntryView class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 17:05'!
model: aLogEntry
	^ self new initializeWithModel: aLogEntry! !

!ControllerLogEntryView methodsFor: 'initialization' stamp: 'EmilianoMenendez 10/22/2013 16:09'!
initializeWithModel: aLogEntry
	model := aLogEntry! !

!ControllerLogEntryView methodsFor: 'model' stamp: 'EmilianoMenendez 10/22/2013 17:06'!
model
	^ model! !

!ControllerLogEntryView methodsFor: 'rendering' stamp: 'EmilianoMenendez 10/22/2013 17:51'!
renderContentOn: html
	| requestView responseView |

	html tableRow: [ 
		html tableData: self model sequenceNumber.
		requestView := CommandRequestView model: self model request.
		html tableData: requestView.
		responseView := CommandResponseView model: self model response.
		html tableData: responseView.
	].
! !

SatelliteControlView subclass: #ControllerLogView
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite-Web'!

!ControllerLogView class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 16:12'!
model: aControllerLog
	^ self new initializeWithModel: aControllerLog! !

!ControllerLogView methodsFor: 'initialization' stamp: 'EmilianoMenendez 10/22/2013 16:12'!
initializeWithModel: aControllerLog
	model := aControllerLog! !

!ControllerLogView methodsFor: 'model' stamp: 'EmilianoMenendez 10/22/2013 21:01'!
model
	^ model! !

!ControllerLogView methodsFor: 'rendering' stamp: 'EmilianoMenendez 10/22/2013 21:44'!
renderContentOn: html
	| table |
	
	table := html table.
	table class: 'pure-table pure-table-bordered'.
	table with: [
		html tableHead: [ 
			html tableRow: [ 
				html tableHeading: 'Sequence Number'.
				html tableHeading: 'Request'.
				html tableHeading: 'Response'.
			].
		].
		model entries do: [ :logEntry | 
			html render: (ControllerLogEntryView model: logEntry).
		].
	].


! !

SatelliteControlWebComponent subclass: #SatelliteControlWebApp
	instanceVariableNames: 'satelliteController commandRequest commandRequestView controllerLogView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite-Web'!

!SatelliteControlWebApp class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 12:05'!
canBeRoot
	^ true! !

!SatelliteControlWebApp class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 12:26'!
initialize
	WAAdmin register: self asApplicationAt: 'satellitecontrol'! !

!SatelliteControlWebApp methodsFor: 'initialization' stamp: 'EmilianoMenendez 10/22/2013 21:04'!
initialize
	| satellite radio |
	
	super initialize.
	
	satellite := SatelliteTest satelliteWithAllSubsystems.
	radio := SatelliteControllerRadioStub connectTo: satellite.
	"radio := SatelliteControllerRadio connectTo: #[127 0 1 1] port: 4445."
	
	satelliteController := SatelliteController newWith: radio.! !

!SatelliteControlWebApp methodsFor: 'rendering' stamp: 'EmilianoMenendez 10/22/2013 17:10'!
renderContentOn: html
	| sequenceNumber |
	
	html anchor
		callback: [sequenceNumber := self sendCommand];
		with: 'Send Command'.

	html break.
	
	sequenceNumber ifNotNil: [
		html text: 'Command Sent. Sequence number: ', sequenceNumber printString.
		html break.
	].

	html anchor
		callback: [ self showLog ];
		with: 'Show Log'.
! !

!SatelliteControlWebApp methodsFor: 'actions' stamp: 'EmilianoMenendez 10/21/2013 21:24'!
sendCommand
	"show a form and get a CommandRequest after submitting the form."
	| subsystem commandDefinition sequenceNumber data |
	commandRequest := self call: CommandRequestForm new.

	"TODO: get subsystem by ID".
	subsystem := SatelliteTest platformSubsystem.

	"TODO: get command definition by command ID"
	commandDefinition := CommandDefinition getNameCommand.

	data := OrderedCollection new.

	"exercise"
	sequenceNumber := satelliteController sendCommand: commandDefinition toSubsystem: subsystem withData: data.
	
	^ sequenceNumber.! !

!SatelliteControlWebApp methodsFor: 'actions' stamp: 'EmilianoMenendez 10/22/2013 17:54'!
showLog
	| log |
	
	satelliteController newIncomingMessages.
	log := satelliteController log.

	self render: (ControllerLogView model: log).
! !

!SatelliteControlWebApp methodsFor: 'actions' stamp: 'EmilianoMenendez 10/22/2013 17:55'!
showLog: html
	| log |
	
	satelliteController newIncomingMessages.
	log := satelliteController log.

	html render: (ControllerLogView model: log).
! !

!SatelliteControlWebComponent methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 21:09'!
updateRoot: anHtmlRoot
	| cssUrl |
	
	super updateRoot: anHtmlRoot.
	
	"cssUrl := 'http://seaside.st/styles/main.css'."
	cssUrl := 'http://yui.yahooapis.com/pure/0.3.0/pure-min.css'.
	
	anHtmlRoot stylesheet url: cssUrl.! !

Object subclass: #BeaconDefinition
	instanceVariableNames: 'parameters id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!BeaconDefinition methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 14:13'!
id
	^ id! !

!BeaconDefinition methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 14:13'!
initialize
	id := #[255 255 240].

	parameters := OrderedCollection new.

	"subsystem 0 PLATFORM telemetry"
	parameters addAll: CommandDefinition platformTelemetry responseDefinition.
	"subsystem 1 MEMORY telemetry"
	parameters addAll: CommandDefinition memoryTelemetry responseDefinition.
	"subsystem 2 POWER telemetry"
	parameters addAll: CommandDefinition powerTelemetry responseDefinition.
	"subsystem 3 THERMAL telemetry"
	parameters addAll: CommandDefinition thermalTelemetry responseDefinition.
	"subsystem 4 CDH telemetry"
	parameters addAll: CommandDefinition cdhTelemetry responseDefinition.! !

!BeaconDefinition methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 10:48'!
requestDefinition
	^ nil
! !

!BeaconDefinition methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/19/2013 12:39'!
responseDefinition
	^ parameters
! !

BeaconDefinition subclass: #ShortBeaconDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!ShortBeaconDefinition methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 14:14'!
initialize
	id := #[255 255 243].

	parameters := OrderedCollection new.
	"subsystem 0 PLATFORM short telemetry is empty"
	"subsystem 1 MEMORY short telemetry is empty"
	"subsystem 2 POWER short telemetry is empty"
	"subsystem 3 THERMAL short telemetry"
	parameters addAll: CommandDefinition thermalShortTelemetry responseDefinition.
	"subsystem 4 CDH short telemetry"
	parameters addAll: CommandDefinition cdhShortTelemetry responseDefinition.
! !

Object subclass: #Command
	instanceVariableNames: 'id executeBlock requestDefinition outputDefinition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!Command class methodsFor: 'cdh' stamp: 'EzequielDavidovichCaballero 10/2/2013 21:20'!
cdhDelayBeacon
	| entryParameters |
	entryParameters := OrderedCollection new.
	entryParameters add: (UnsignedIntegerCommandParameter new: 16).
	^ self new
		initializeWith: 32
		receiving: entryParameters
		responding: OrderedCollection new
		executing: [  ]! !

!Command class methodsFor: 'cdh' stamp: 'EzequielDavidovichCaballero 10/9/2013 21:27'!
cdhGetRadio
	| answerParameters |
	
	answerParameters := OrderedCollection new.
	answerParameters add: String new.
	^ self new
		initializeWith: 36
		receiving: OrderedCollection new
		responding: answerParameters
		executing: [  ]! !

!Command class methodsFor: 'cdh' stamp: 'EzequielDavidovichCaballero 10/9/2013 21:18'!
cdhSetBeaconData
	| entryParameters |
	entryParameters := OrderedCollection new.
	entryParameters add: String new.
	^ self new
		initializeWith: 35
		receiving: entryParameters
		responding: OrderedCollection new
		executing: [  ]! !

!Command class methodsFor: 'cdh' stamp: 'EzequielDavidovichCaballero 10/9/2013 21:18'!
cdhSetBeaconInterval
	| entryParameters |
	entryParameters := OrderedCollection new.
	entryParameters add: (UnsignedIntegerCommandParameter new: 8).
	^ self new
		initializeWith: 34
		receiving: entryParameters
		responding: OrderedCollection new
		executing: [  ]! !

!Command class methodsFor: 'cdh' stamp: 'EzequielDavidovichCaballero 10/9/2013 21:39'!
cdhSetRadio
	| answerParameters entryParameters enum |
	
	entryParameters := OrderedCollection new.
	entryParameters add: String new.
	enum := OrderedCollection new: 12.
	enum addAll:  ('RV_SUCCESS', 'RV_TIMEOUT', 'RV_BUSY', 'RV_ILLEGAL', 'RV_NOSPACE', 'RV_ERROR', 'RV_EXIST', 'RV_NOENT', 'RV_PERM', 'RV_PARTIAL', 'RV_NACK', 'RV_NOTIMPLEMENTED') . 
	answerParameters := OrderedCollection new.
	answerParameters add: EnumCommandParameter.
	
	^ self new
		initializeWith: 37
		receiving: entryParameters
		responding: answerParameters
		executing: [  ]! !

!Command class methodsFor: 'cdh' stamp: 'EzequielDavidovichCaballero 10/9/2013 21:18'!
cdhSet_tx_power
	| entryParameters |
	entryParameters := OrderedCollection new.
	entryParameters add: (UnsignedIntegerCommandParameter new: 8).
	^ self new
		initializeWith: 33
		receiving: entryParameters
		responding: OrderedCollection new
		executing: [  ]! !

!Command class methodsFor: 'cdh' stamp: 'EzequielDavidovichCaballero 10/9/2013 16:51'!
cdhShortTelemetry
	
		|answerParameters|

		answerParameters:= OrderedCollection new.
		answerParameters add: (UnsignedIntegerCommandParameter new: 8).


	^ self new initializeWith: 2
		receiving: OrderedCollection new
		responding: answerParameters
		executing: [ :aSubsystem |	aSubsystem shortTelemetry ]! !

!Command class methodsFor: 'cdh' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/17/2013 14:36'!
cdhTelemetry
	
		|answerParameters|

		answerParameters:= OrderedCollection new.
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'lastSeenSequenceNumber' andBitSize: 32).
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'nextBeaconEnableTicks' andBitSize: 32).
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'antennaDeployStatus' andBitSize: 8).

	^ self new initializeWith: 1
		receiving: OrderedCollection new
		responding: answerParameters
		executing: [ :aSubsystem |	aSubsystem telemetry ]! !

!Command class methodsFor: 'general' stamp: 'EmilianoMenendez 10/22/2013 15:32'!
getNameCommand
	
		|answerParameters|

		answerParameters:= OrderedCollection new: 1.
		answerParameters add: (StringCommandParameter newWithName: 'name' andBitSize: 0).

	^ self new initializeWith: 0
		receiving: OrderedCollection new
		responding: answerParameters
		executing: [ :aSubsystem |	| data |
	
			data := OrderedCollection new.
			data add: (Association key: 'name' value: aSubsystem name).
	
			DataCommandResponse for: answerParameters withSequenceNumber: 0 andData: data. ]! !

!Command class methodsFor: 'memory' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/17/2013 14:33'!
memoryReadAddress
	
		|parameters answerParameters|

		parameters:= OrderedCollection new.
		parameters add: (UnsignedIntegerCommandParameter newWithName: 'address' andBitSize: 32).
		
		answerParameters := OrderedCollection new.
		answerParameters add: (ArrayCommandParameter newWithElementType: UnsignedIntegerCommandParameter andElementSize: 8 andLength: 200).



	^ self new initializeWith: 32
		receiving: parameters
		responding: answerParameters
		executing: [ :aSubsystem |	
					
		]! !

!Command class methodsFor: 'memory' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:29'!
memoryReadChunkedAddress
	
		|parameters answerParameters |

		parameters:= OrderedCollection new.
			5 timesRepeat: [ 
		parameters add: (UnsignedIntegerCommandParameter new: 32). 
	].

		answerParameters := OrderedCollection new.
		answerParameters add: (UnsignedIntegerCommandParameter new:32).
		answerParameters add: (ArrayCommandParameter newWithElementType: (UnsignedIntegerCommandParameter new: 8) andElementSize: 8 andLength: 200 ).
	


	^ self new initializeWith: 45
		receiving: parameters
		responding: answerParameters
		executing: [  ]! !

!Command class methodsFor: 'memory' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:34'!
memoryReadLongAddress
	
		|parameters answerParameters|

		parameters:= OrderedCollection new.
		parameters add: (UnsignedIntegerCommandParameter new: 32).
		parameters add: (UnsignedIntegerCommandParameter new: 32).
		
		answerParameters := OrderedCollection new.
		answerParameters add: (UnsignedIntegerCommandParameter new: 32).
		answerParameters add: (ArrayCommandParameter newWithElementType: UnsignedIntegerCommandParameter andElementSize: 8 andLength: 200).



	^ self new initializeWith: 44
		receiving: parameters
		responding: answerParameters
		executing: [ :aSubsystem |	
					
		]! !

!Command class methodsFor: 'memory' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:38'!
memoryShortTelemetry
	
		|parameters answerParameters|

		parameters:= OrderedCollection new.
			
		answerParameters := OrderedCollection new.



	^ self new initializeWith: 2
		receiving: parameters
		responding: answerParameters
		executing: [ :aSubsystem |	aSubsystem shortTelemetry 
					
		]! !

!Command class methodsFor: 'memory' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/17/2013 14:37'!
memoryTelemetry
	
		|parameters answerParameters|

		parameters:= OrderedCollection new.
			
		answerParameters := OrderedCollection new.
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'free' andBitSize: 32).



	^ self new initializeWith: 1
		receiving: parameters
		responding: answerParameters
		executing: [ :aSubsystem |	aSubsystem telemetry
					
		]! !

!Command class methodsFor: 'memory' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:34'!
memoryWriteAddress
	
		|parameters answerParameters|

		parameters:= OrderedCollection new.
		parameters add: (UnsignedIntegerCommandParameter new: 32).
		parameters add: (StringCommandParameter new: 8).
		
		answerParameters := OrderedCollection new.



	^ self new initializeWith: 33
		receiving: parameters
		responding: answerParameters
		executing: [ :aSubsystem |	
					
		]! !

!Command class methodsFor: 'platform' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:05'!
platformReset
	


	^ self new initializeWith: 33
		receiving:  OrderedCollection new
		responding: OrderedCollection new
		executing: [  ]! !

!Command class methodsFor: 'platform' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:05'!
platformSetMode
	
		|parameters|

		parameters:= OrderedCollection new.
		parameters add: (UnsignedIntegerCommandParameter new: 8).


	^ self new initializeWith: 32
		receiving: parameters
		responding: OrderedCollection new
		executing: []! !

!Command class methodsFor: 'platform' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:02'!
platformShortTelemetry
	
	

	^ self new initializeWith: 2
		receiving: OrderedCollection new
		responding: OrderedCollection new
		executing: [ :aSubsystem |	aSubsystem shortTelemetry ]! !

!Command class methodsFor: 'platform' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/17/2013 14:40'!
platformTelemetry

	
	| answerParameters |
	answerParameters := OrderedCollection new.
	answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'tickCount' andBitSize: 64).
	answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'currentMode' andBitSize: 8).

	^ self new initializeWith: 1
		receiving: OrderedCollection new
		responding: answerParameters
		executing: [ :aSubsystem |	aSubsystem telemetry ]! !

!Command class methodsFor: 'platform' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:49'!
platformVersion
	|answerParameters|
	
	answerParameters := OrderedCollection new.
	answerParameters add: String new.


	^ self new initializeWith: 34
		receiving:  OrderedCollection new
		responding: answerParameters 
		executing: [  ]! !

!Command class methodsFor: 'power' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:54'!
powerReset
	
	
	^ self new initializeWith: 32
		receiving: OrderedCollection new
		responding: OrderedCollection new
		executing: []! !

!Command class methodsFor: 'power' stamp: 'EzequielDavidovichCaballero 10/9/2013 19:57'!
powerShortTelemetry
	
	
	^ self new initializeWith: 2
		receiving: OrderedCollection new
		responding: OrderedCollection new
		executing: [ :aSubsystem |	aSubsystem shortTelemetry ]! !

!Command class methodsFor: 'power' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:54'!
powerStbGetSwitchesState
	
	|answerParameters|
	
	answerParameters := OrderedCollection new.
	answerParameters add: (UnsignedIntegerCommandParameter new: 24).
	
	^ self new initializeWith: 35
		receiving: OrderedCollection new
		responding: answerParameters
		executing: [ :aSubsystem |	]! !

!Command class methodsFor: 'power' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:54'!
powerStbSetInitialState
	
	|parameters|
	
	parameters := OrderedCollection new.
	parameters add: (UnsignedIntegerCommandParameter new: 24).
	
	^ self new initializeWith:37
		receiving: parameters 
		responding: OrderedCollection new
		executing: [ :aSubsystem |	]! !

!Command class methodsFor: 'power' stamp: 'EzequielDavidovichCaballero 10/9/2013 16:37'!
powerStbSetSwitchesState
	
		| parameters answerParameters |

	parameters := OrderedCollection new.
	parameters add: (UnsignedIntegerCommandParameter new: 24).
	
	answerParameters := OrderedCollection new.

	^ self new initializeWith: 36
		receiving: parameters
		responding: answerParameters
		executing: [ ]! !

!Command class methodsFor: 'power' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/17/2013 15:11'!
powerTelemetry
	
		|answerParameters|

		answerParameters:= OrderedCollection new.
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'low_voltage_counter' andBitSize: 16). 
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'battery_v' andBitSize: 16).
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'array_X_v' andBitSize: 16).
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'array_Xp_mA' andBitSize: 16).
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'array_Xm_mA' andBitSize: 16).
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'array_Y_v' andBitSize: 16).
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'array_Yp_mA' andBitSize: 16).
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'array_Y_mA' andBitSize: 16).
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'array_Z_v' andBitSize: 16).
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'array_Zp_mA' andBitSize: 16).
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'array_Zm_mA' andBitSize: 16).
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: '_3v3_mA' andBitSize: 16).
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: '_5v_mA' andBitSize: 16).


	^ self new initializeWith: 1
		receiving: OrderedCollection new
		responding: answerParameters
		executing: [ :aSubsystem |	aSubsystem telemetry ]! !

!Command class methodsFor: 'thermal' stamp: 'EzequielDavidovichCaballero 10/9/2013 15:45'!
thermalSetMatrixKey
	
		|parameters|

		parameters:= OrderedCollection new.
		parameters add: (UnsignedIntegerCommandParameter new: 32).


	^ self new initializeWith: 32
		receiving: parameters
		responding: OrderedCollection new
		executing: [ :aSubsystem |	
					aSubsystem setMatrixKey: ((parameters at: 1) value).
					VoidCommandResponse new.
		]! !

!Command class methodsFor: 'thermal' stamp: 'EzequielDavidovichCaballero 10/9/2013 16:21'!
thermalShortTelemetry
	
		|answerParameters|

		answerParameters:= OrderedCollection new.
		answerParameters add: (UnsignedIntegerCommandParameter new: 8).


	^ self new initializeWith: 2
		receiving: OrderedCollection new
		responding: answerParameters
		executing: [ :aSubsystem |	aSubsystem shortTelemetry ]! !

!Command class methodsFor: 'thermal' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/17/2013 15:22'!
thermalTelemetry
	
		|answerParameters|

		answerParameters:= OrderedCollection new.
		answerParameters add: (SignedIntegerCommandParameter newWithName: 'battery_temp' andBitSize: 16).
		answerParameters add: (SignedIntegerCommandParameter newWithName: 'radio_temp' andBitSize: 16).


	^ self new initializeWith: 1
		receiving: OrderedCollection new
		responding: answerParameters
		executing: [ :aSubsystem |	aSubsystem telemetry ]! !

!Command methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 13:44'!
= aCommand
	^ id = aCommand id! !

!Command methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/16/2013 18:14'!
addParameterValue: aValue
	| parameter |
	
	parameter := requestDefinition at: (requestDefinition findFirst: [ :p | (p value) isNil]).
	
	parameter value: aValue.
! !

!Command methodsFor: 'executing' stamp: 'EzequielDavidovichCaballero 10/2/2013 22:51'!
executeOn: aSubsystem
	^ executeBlock value: aSubsystem! !

!Command methodsFor: 'accessing' stamp: 'EzequielDavidovichCaballero 9/15/2013 17:46'!
id
	^ id! !

!Command methodsFor: 'initialization' stamp: 'EzequielDavidovichCaballero 10/16/2013 18:15'!
initializeWith: anId receiving: entryParameters responding: answerParameters executing: aBlock

	id := anId.
	requestDefinition := entryParameters.
	outputDefinition := answerParameters.
	executeBlock := aBlock ! !

Object subclass: #CommandDefinition
	instanceVariableNames: 'id requestDefinition outputDefinition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!CommandDefinition class methodsFor: 'cdh' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:26'!
cdhDelayBeacon
	| entryParameters |
	entryParameters := OrderedCollection new.
	entryParameters add: (UnsignedIntegerCommandParameter new: 16).
	^ self new
		initializeWith: 32
		receiving: entryParameters
		responding: OrderedCollection new
! !

!CommandDefinition class methodsFor: 'cdh' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:26'!
cdhGetRadio
	| answerParameters |
	
	answerParameters := OrderedCollection new.
	answerParameters add: String new.
	^ self new
		initializeWith: 36
		receiving: OrderedCollection new
		responding: answerParameters
! !

!CommandDefinition class methodsFor: 'cdh' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:26'!
cdhSetBeaconData
	| entryParameters |
	entryParameters := OrderedCollection new.
	entryParameters add: String new.
	^ self new
		initializeWith: 35
		receiving: entryParameters
		responding: OrderedCollection new
! !

!CommandDefinition class methodsFor: 'cdh' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:26'!
cdhSetBeaconInterval
	| entryParameters |
	entryParameters := OrderedCollection new.
	entryParameters add: (UnsignedIntegerCommandParameter new: 8).
	^ self new
		initializeWith: 34
		receiving: entryParameters
		responding: OrderedCollection new
! !

!CommandDefinition class methodsFor: 'cdh' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:26'!
cdhSetRadio
	| answerParameters entryParameters enum |
	
	entryParameters := OrderedCollection new.
	entryParameters add: String new.
	enum := OrderedCollection new: 12.
	enum addAll:  ('RV_SUCCESS', 'RV_TIMEOUT', 'RV_BUSY', 'RV_ILLEGAL', 'RV_NOSPACE', 'RV_ERROR', 'RV_EXIST', 'RV_NOENT', 'RV_PERM', 'RV_PARTIAL', 'RV_NACK', 'RV_NOTIMPLEMENTED') . 
	answerParameters := OrderedCollection new.
	answerParameters add: EnumCommandParameter.
	
	^ self new
		initializeWith: 37
		receiving: entryParameters
		responding: answerParameters
! !

!CommandDefinition class methodsFor: 'cdh' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:26'!
cdhSet_tx_power
	| entryParameters |
	entryParameters := OrderedCollection new.
	entryParameters add: (UnsignedIntegerCommandParameter new: 8).
	^ self new
		initializeWith: 33
		receiving: entryParameters
		responding: OrderedCollection new
! !

!CommandDefinition class methodsFor: 'cdh' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 14:06'!
cdhShortTelemetry
	
		|answerParameters|

		answerParameters:= OrderedCollection new.
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'ticksLow' andBitSize: 8).


	^ self new initializeWith: 2
		receiving: OrderedCollection new
		responding: answerParameters
! !

!CommandDefinition class methodsFor: 'cdh' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 14:02'!
cdhTelemetry
	
		|answerParameters|

		answerParameters:= OrderedCollection new.
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'lastSeenSequenceNumber' andBitSize: 32).
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'nextBeaconEnableTicks' andBitSize: 32).
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'antennaDeployStatus' andBitSize: 8).

	^ self new initializeWith: 1
		receiving: OrderedCollection new
		responding: answerParameters
! !

!CommandDefinition class methodsFor: 'general' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/19/2013 12:12'!
getNameCommand
	
		|answerParameters|

		answerParameters:= OrderedCollection new: 1.
		answerParameters add: (StringCommandParameter newWithName: 'name' andBitSize: 0).

	^ self new initializeWith: 0
		receiving: OrderedCollection new
		responding: answerParameters
! !

!CommandDefinition class methodsFor: 'memory' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:27'!
memoryReadAddress
	
		|parameters answerParameters|

		parameters:= OrderedCollection new.
		parameters add: (UnsignedIntegerCommandParameter new: 32).
		
		answerParameters := OrderedCollection new.
		answerParameters add: (ArrayCommandParameter newWithElementType: UnsignedIntegerCommandParameter andElementSize: 8 andLength: 200).



	^ self new initializeWith: 32
		receiving: parameters
		responding: answerParameters
! !

!CommandDefinition class methodsFor: 'memory' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:27'!
memoryReadChunkedAddress
	
		|parameters answerParameters |

		parameters:= OrderedCollection new.
			5 timesRepeat: [ 
		parameters add: (UnsignedIntegerCommandParameter new: 32). 
	].

		answerParameters := OrderedCollection new.
		answerParameters add: (UnsignedIntegerCommandParameter new:32).
		answerParameters add: (ArrayCommandParameter newWithElementType: (UnsignedIntegerCommandParameter new: 8) andElementSize: 8 andLength: 200 ).
	


	^ self new initializeWith: 45
		receiving: parameters
		responding: answerParameters
! !

!CommandDefinition class methodsFor: 'memory' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:27'!
memoryReadLongAddress
	
		|parameters answerParameters|

		parameters:= OrderedCollection new.
		parameters add: (UnsignedIntegerCommandParameter new: 32).
		parameters add: (UnsignedIntegerCommandParameter new: 32).
		
		answerParameters := OrderedCollection new.
		answerParameters add: (UnsignedIntegerCommandParameter new: 32).
		answerParameters add: (ArrayCommandParameter newWithElementType: UnsignedIntegerCommandParameter andElementSize: 8 andLength: 200).



	^ self new initializeWith: 44
		receiving: parameters
		responding: answerParameters
! !

!CommandDefinition class methodsFor: 'memory' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:27'!
memoryShortTelemetry
	
		|parameters answerParameters|

		parameters:= OrderedCollection new.
			
		answerParameters := OrderedCollection new.



	^ self new initializeWith: 2
		receiving: parameters
		responding: answerParameters
! !

!CommandDefinition class methodsFor: 'memory' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 13:59'!
memoryTelemetry
	
		|parameters answerParameters|

		parameters:= OrderedCollection new.
			
		answerParameters := OrderedCollection new.
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'free' andBitSize: 32).



	^ self new initializeWith: 1
		receiving: parameters
		responding: answerParameters
! !

!CommandDefinition class methodsFor: 'memory' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:27'!
memoryWriteAddress
	
		|parameters answerParameters|

		parameters:= OrderedCollection new.
		parameters add: (UnsignedIntegerCommandParameter new: 32).
		parameters add: (StringCommandParameter new: 8).
		
		answerParameters := OrderedCollection new.



	^ self new initializeWith: 33
		receiving: parameters
		responding: answerParameters
! !

!CommandDefinition class methodsFor: 'platform' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:27'!
platformReset
	


	^ self new initializeWith: 33
		receiving:  OrderedCollection new
		responding: OrderedCollection new
! !

!CommandDefinition class methodsFor: 'platform' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:28'!
platformSetMode
	
		|parameters|

		parameters:= OrderedCollection new.
		parameters add: (UnsignedIntegerCommandParameter new: 8).


	^ self new initializeWith: 32
		receiving: parameters
		responding: OrderedCollection new
! !

!CommandDefinition class methodsFor: 'platform' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:28'!
platformShortTelemetry
	
	

	^ self new initializeWith: 2
		receiving: OrderedCollection new
		responding: OrderedCollection new
! !

!CommandDefinition class methodsFor: 'platform' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 13:59'!
platformTelemetry

	
	| answerParameters |
	answerParameters := OrderedCollection new.
	answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'tickCount' andBitSize: 64).
	answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'currentMode' andBitSize: 8).

	^ self new initializeWith: 1
		receiving: OrderedCollection new
		responding: answerParameters! !

!CommandDefinition class methodsFor: 'platform' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:28'!
platformVersion
	|answerParameters|
	
	answerParameters := OrderedCollection new.
	answerParameters add: String new.


	^ self new initializeWith: 34
		receiving:  OrderedCollection new
		responding: answerParameters 
! !

!CommandDefinition class methodsFor: 'power' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:28'!
powerReset
	
	
	^ self new initializeWith: 32
		receiving: OrderedCollection new
		responding: OrderedCollection new
! !

!CommandDefinition class methodsFor: 'power' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:28'!
powerShortTelemetry
	
	
	^ self new initializeWith: 2
		receiving: OrderedCollection new
		responding: OrderedCollection new
! !

!CommandDefinition class methodsFor: 'power' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:28'!
powerStbGetSwitchesState
	
	|answerParameters|
	
	answerParameters := OrderedCollection new.
	answerParameters add: (UnsignedIntegerCommandParameter new: 24).
	
	^ self new initializeWith: 35
		receiving: OrderedCollection new
		responding: answerParameters
! !

!CommandDefinition class methodsFor: 'power' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:28'!
powerStbSetInitialState
	
	|parameters|
	
	parameters := OrderedCollection new.
	parameters add: (UnsignedIntegerCommandParameter new: 24).
	
	^ self new initializeWith:37
		receiving: parameters 
		responding: OrderedCollection new
! !

!CommandDefinition class methodsFor: 'power' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:28'!
powerStbSetSwitchesState
	
		| parameters answerParameters |

	parameters := OrderedCollection new.
	parameters add: (UnsignedIntegerCommandParameter new: 24).
	
	answerParameters := OrderedCollection new.

	^ self new initializeWith: 36
		receiving: parameters
		responding: answerParameters
! !

!CommandDefinition class methodsFor: 'power' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 14:01'!
powerTelemetry
	
		|answerParameters|

		answerParameters:= OrderedCollection new.
	      answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'low_voltage_counter' andBitSize: 16). 
	      answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'battery_v' andBitSize: 16).
	      answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'array_X_v' andBitSize: 16).
	      answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'array_Xp_mA' andBitSize: 16).
	      answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'array_Xm_mA' andBitSize: 16).
	      answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'array_Y_v' andBitSize: 16).
	      answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'array_Yp_mA' andBitSize: 16).
	      answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'array_Y_mA' andBitSize: 16).
	      answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'array_Z_v' andBitSize: 16).
	      answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'array_Zp_mA' andBitSize: 16).
	      answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'array_Zm_mA' andBitSize: 16).
	      answerParameters add: (UnsignedIntegerCommandParameter newWithName: '_3v3_mA' andBitSize: 16).
	      answerParameters add: (UnsignedIntegerCommandParameter newWithName: '_5v_mA' andBitSize: 16).


	^ self new initializeWith: 1
		receiving: OrderedCollection new
		responding: answerParameters
! !

!CommandDefinition class methodsFor: 'thermal' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:28'!
thermalSetMatrixKey
	
		|parameters|

		parameters:= OrderedCollection new.
		parameters add: (UnsignedIntegerCommandParameter new: 32).


	^ self new initializeWith: 32
		receiving: parameters
		responding: OrderedCollection new
! !

!CommandDefinition class methodsFor: 'thermal' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 14:06'!
thermalShortTelemetry
	
		|answerParameters|

		answerParameters:= OrderedCollection new.
		answerParameters add: (UnsignedIntegerCommandParameter newWithName: 'battery_temp' andBitSize: 8).


	^ self new initializeWith: 2
		receiving: OrderedCollection new
		responding: answerParameters
! !

!CommandDefinition class methodsFor: 'thermal' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 14:01'!
thermalTelemetry
	
		|answerParameters|

		answerParameters:= OrderedCollection new.
      	answerParameters add: (SignedIntegerCommandParameter newWithName: 'battery_temp' andBitSize: 16).
      	answerParameters add: (SignedIntegerCommandParameter newWithName: 'radio_temp' andBitSize: 16).



	^ self new initializeWith: 1
		receiving: OrderedCollection new
		responding: answerParameters
! !

!CommandDefinition methodsFor: 'accessing' stamp: 'EzequielDavidovich 10/16/2013 18:46'!
id
	^ id! !

!CommandDefinition methodsFor: 'initialization' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 12:25'!
initializeWith: anId receiving: entryParameters responding: answerParameters

	id := anId.
	requestDefinition := entryParameters.
	outputDefinition := answerParameters.
! !

!CommandDefinition methodsFor: 'initialization' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 11:41'!
requestDefinition
	^ requestDefinition! !

!CommandDefinition methodsFor: 'initialization' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 11:41'!
responseDefinition
	^ outputDefinition! !

Object subclass: #CommandMessage
	instanceVariableNames: 'definition sequenceNumber data time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

CommandMessage subclass: #Beacon
	instanceVariableNames: 'subsystemsOrderedById'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!Beacon class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 10:22'!
newFromPackage: aByteArray
	^ self new initializeFromPackage: aByteArray
! !

!Beacon class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 13:03'!
newFromSubsystems: subsystems 
	^ self new initializeFromSubsystems: subsystems
! !

!Beacon methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/17/2013 15:30'!
collectTelemetry

	data :=  OrderedCollection new.
	
	subsystemsOrderedById do: [ :subsystem | data addAll: (subsystem telemetry data) ].

	^ data.
! !

!Beacon methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/24/2013 15:52'!
initializeFromSubsystems: subsystems
	"Used for instance construction on the Satellite side."
	self initializeMessageDefinition.
	
	time := DateAndTime now.

	subsystemsOrderedById := SortedCollection sortBlock: [ :current :new | current id < new id ].

	subsystemsOrderedById addAll: subsystems.		

	self collectTelemetry.
! !

!Beacon methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 11:52'!
initializeMessageDefinition
	definition := BeaconDefinition new.
! !

!Beacon methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 20:13'!
serialize

	| telemetrySet stream |

	telemetrySet := self collectTelemetry.
				
	stream := WriteStream on: ByteArray new.
		
	stream nextPutAll: definition id.

	"TODO: improve!!"
	definition responseDefinition do: [ :parameter |
		| association |
		association := telemetrySet detect: [ :ass | ass key = parameter name ].
		parameter value: association value.
		stream nextPutAll: (parameter serialize).
	].

	^ stream contents.! !

Beacon subclass: #ShortBeacon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!ShortBeacon methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/17/2013 23:49'!
collectTelemetry

	data :=  OrderedCollection new.
	
	subsystemsOrderedById do: [ :subsystem | data addAll: (subsystem shortTelemetry data) ].

	^ data.
! !

!ShortBeacon methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 11:52'!
initializeMessageDefinition
	definition := ShortBeaconDefinition new.
! !

!CommandMessage methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 13:06'!
= aResponse
	^ data = aResponse data! !

!CommandMessage methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 13:06'!
data
	^ data! !

!CommandMessage methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 19:12'!
definition
	^ definition! !

!CommandMessage methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/19/2013 11:44'!
sequenceNumber
	^ sequenceNumber! !

!CommandMessage methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/19/2013 11:44'!
sequenceNumber: aSequenceNumber
	sequenceNumber := aSequenceNumber! !

!CommandMessage methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 19:40'!
time
	^ time! !

CommandMessage subclass: #CommandRequest
	instanceVariableNames: 'commandId subsystemId subsystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!CommandRequest class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 15:35'!
for: aCommandDefinition andSubsystem: aSubsystem withSequenceNumber: aSequenceNumber
	^ self for: aCommandDefinition andSubsystem: aSubsystem withSequenceNumber: aSequenceNumber andData: OrderedCollection new.! !

!CommandRequest class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 15:38'!
for: aCommandDefinition andSubsystem: aSubsystem withSequenceNumber: aSequenceNumber andData: aData
	^ self new initializeWithDefinition: aCommandDefinition andSubsystem: aSubsystem andSequenceNumber: aSequenceNumber andData: aData.! !

!CommandRequest methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 18:29'!
addParameterValue: aValue
	| parameter |
	
	parameter := self definition at: (self definition findFirst: [ :p | (p value) isNil]).
	
	parameter value: aValue.
! !

!CommandRequest methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 14:51'!
commandId
	^ commandId
! !

!CommandRequest methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 16:05'!
commandId: aCommandId
	commandId := aCommandId
! !

!CommandRequest methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 15:39'!
initializeWithDefinition: aCommandDefinition andSubsystem: aSubsystem andSequenceNumber: aSequenceNumber andData: aData
	subsystem := aSubsystem.
	commandId := aCommandDefinition id.
	definition := aCommandDefinition requestDefinition.
	aData do: [ :value | self addParameterValue: value ].
	sequenceNumber := aSequenceNumber.
	time := DateAndTime now.! !

!CommandRequest methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 18:26'!
serialize
	
	| stream |
			
	stream := WriteStream on: ByteArray new.
		
	stream nextPut: (commandId asByte).

	self definition do: [ :parameter |
		stream nextPutAll: (parameter serialize).
	].

	^ stream contents.! !

!CommandRequest methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 15:40'!
subsystem
	^ subsystem! !

!CommandRequest methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 15:29'!
subsystemId
	^ subsystemId! !

!CommandRequest methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 16:05'!
subsystemId: aSubsystemId
	subsystemId := aSubsystemId
! !

CommandMessage subclass: #CommandResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!CommandResponse class methodsFor: 'instance creation' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 11:32'!
from: aByteArray using: aCommandDefinition 
	^ self new initializeFrom: aByteArray using: aCommandDefinition! !

!CommandResponse methodsFor: 'initialization' stamp: 'EmilianoMenendez 10/21/2013 19:43'!
initializeFrom: aByteArray using: aCommandDefinition
	
	| readStream |
	
	definition := aCommandDefinition responseDefinition.

	sequenceNumber := (aByteArray first: 3) asInteger.
	
	definition isEmpty ifTrue: [ ^VoidCommandResponse newWithSequenceNumber: sequenceNumber. ].

	data := OrderedCollection new.

	readStream := ReadStream on: (aByteArray allButFirst: 3).

	definition do: [ :parameter | data add: (parameter deserialize: readStream)].

	time := DateAndTime now.! !

CommandResponse subclass: #DataCommandResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!DataCommandResponse class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 15:32'!
for: aMessageDefinition withSequenceNumber: aSequenceNumber andData: data
	^ self new initializeWithDefinition: aMessageDefinition andSequenceNumber: aSequenceNumber andData: data.! !

!DataCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 20:10'!
initializeWithDefinition: aMessageDefinition andSequenceNumber: aSequenceNumber andData: aData.
	definition := aMessageDefinition.
	sequenceNumber := aSequenceNumber.
	data := aData.
	time := DateAndTime now.! !

!DataCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/19/2013 12:11'!
serialize
	
	| stream sequenceNumberByteArray |
			
	stream := WriteStream on: ByteArray new.

	sequenceNumberByteArray := ByteArray new: 3.
	sequenceNumberByteArray replaceFrom: 3 - ((sequenceNumber asByteArray) size) + 1 to: 3 with: sequenceNumber asByteArray.
	
	stream nextPutAll: (sequenceNumberByteArray).

	"TODO: improve!!"
	definition do: [ :parameter |
		| association |
		association := data detect: [ :ass | ass key = parameter name ].
		parameter value: association value.
		stream nextPutAll: (parameter serialize).
	].


	^ stream contents.! !

CommandResponse subclass: #VoidCommandResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!VoidCommandResponse class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 13:55'!
newWithSequenceNumber: aSequenceNumber
	^ self new initializeWithSequenceNumber: aSequenceNumber ! !

!VoidCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 19:17'!
= anotherResponse
	^ anotherResponse isKindOf: VoidCommandResponse! !

!VoidCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 19:45'!
initializeWithSequenceNumber: aSequenceNumber
	sequenceNumber := aSequenceNumber.
	data := OrderedCollection new.
	time := DateAndTime now.! !

Object subclass: #CommandMessageExchange
	instanceVariableNames: 'commandDefinition request response requestDefinition responseDefinition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!CommandMessageExchange class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 10:47'!
forCommand: aCommandDefinition
	^ self new initializeForCommand: aCommandDefinition.! !

!CommandMessageExchange class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 20:48'!
forCommand: aCommandDefinition andRequest: aCommandRequest
	^ self new initializeForCommand: aCommandDefinition andRequest: aCommandRequest.! !

!CommandMessageExchange methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 10:47'!
initializeForCommand: aCommandDefinition
	self initializeForCommand: aCommandDefinition andRequest: nil.
! !

!CommandMessageExchange methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 20:49'!
initializeForCommand: aCommandDefinition andRequest: aCommandRequest
	requestDefinition := aCommandDefinition requestDefinition.
	responseDefinition := aCommandDefinition responseDefinition.
	request := aCommandRequest.! !

!CommandMessageExchange methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/19/2013 11:21'!
request
	^ request! !

!CommandMessageExchange methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 18:28'!
requestDefinition
	^ requestDefinition.! !

!CommandMessageExchange methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/19/2013 11:20'!
response
	^ response! !

!CommandMessageExchange methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/19/2013 11:20'!
response: aCommandResponse
	response := aCommandResponse.! !

!CommandMessageExchange methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 18:28'!
responseDefinition
	^ responseDefinition.! !

Object subclass: #CommandParameter
	instanceVariableNames: 'value bitSize name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

CommandParameter subclass: #ArrayCommandParameter
	instanceVariableNames: 'type arrayLength elementSize elementType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!ArrayCommandParameter class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 18:08'!
newWithElementType: type andElementSize: elementSize andLength: arrayLength
	^ self new initializeWithElementType: type andElementSize: elementSize andArrayLength: arrayLength.
	! !

!ArrayCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 18:06'!
deserialize: aReadStream 
	| result responseParameter |
	
	result := OrderedCollection new.
	
	[aReadStream atEnd] whileFalse: [ 
		" create an object of type elementType (i.e. UnsignedIntegerCommandParameter) and size in bits elementSize"
		responseParameter := elementType new: elementSize.
		value := responseParameter deserialize: aReadStream.
		result add: value.
	 ].

	^ result.! !

!ArrayCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 17:51'!
elementSize
	^ elementSize! !

!ArrayCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 18:07'!
initializeWithElementType: theType andElementSize: theElementSize andArrayLength: theArrayLength
	elementType := theType.
	elementSize := theElementSize.
	arrayLength := theArrayLength.! !

!CommandParameter class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 16:03'!
new: aSize
	^ self new initializeWithBitSize: aSize! !

!CommandParameter class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/17/2013 14:13'!
newWithName: aName andBitSize: aSize
	^ self new initializeWithName: aName andBitSize: aSize! !

!CommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 16:04'!
byteSize
	^ (bitSize / 8)! !

!CommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 13:16'!
deserialize: aValue
	^ self subclassResponsibility.! !

!CommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/19/2013 10:48'!
initialize
	bitSize := 0! !

!CommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/17/2013 14:34'!
initializeWithBitSize: aSize
	bitSize := aSize! !

!CommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/17/2013 14:12'!
initializeWithName: aName andBitSize: aSize
	name := aName.
	bitSize := aSize! !

!CommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/17/2013 14:15'!
name
	^ name! !

!CommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 13:16'!
serialize
	^ self subclassResponsibility.! !

!CommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 14:22'!
value
	^ value! !

!CommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 14:22'!
value: aValue
	value := aValue! !

CommandParameter subclass: #EnumCommandParameter
	instanceVariableNames: 'labels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!EnumCommandParameter class methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/9/2013 21:44'!
newWith: labels

	^self new initializeWith: labels! !

!EnumCommandParameter methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/9/2013 21:49'!
initializeWith: aCollectionOfLabels

	! !

CommandParameter subclass: #SignedIntegerCommandParameter
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!SignedIntegerCommandParameter methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/28/2013 18:21'!
deserialize: aReadstream 
	| serializedValue sign result |
	
	"take first 2 bytes from the input, first byte is sign"

	sign := aReadstream next asInteger.
	serializedValue := aReadstream next.
	result := serializedValue asInteger.
	
	(sign = 1) ifTrue: [ result := result * -1].
	
	^ result.! !

!SignedIntegerCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/17/2013 16:55'!
serialize
	| valueBytes start stop result signByte |
	
	result := ByteArray new: (self byteSize).

	signByte := 0.

	value < 0 ifTrue: [ signByte := 1 ].
	
	result at: 1 put: signByte.

	valueBytes := value asByteArray.	
	start := (result size) - (valueBytes size) + 1.
	stop := (result size).
	result replaceFrom: start to: stop with: valueBytes.
	
	^ result.! !

CommandParameter subclass: #StringCommandParameter
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!StringCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 19:49'!
deserialize: aReadStream 

	^ aReadStream contents asString.
! !

!StringCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/19/2013 10:55'!
serialize 

	| valueBytes valueSize headerSize header result stream |

	valueBytes := value asByteArray.
	valueSize := valueBytes size.

	headerSize := (self byteSize).
	header := ByteArray new: headerSize.
	(headerSize > 0) ifTrue: [
		header replaceFrom: (headerSize - (valueSize asByteArray size) + 1) to: headerSize with: (valueSize asByteArray).
	].
	
	result := ByteArray new: headerSize + valueSize.
	stream := WriteStream on: result.
	stream nextPutAll: header.
	stream nextPutAll: valueBytes.

	^ result.
! !

CommandParameter subclass: #UnsignedIntegerCommandParameter
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!UnsignedIntegerCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 18:02'!
deserialize: aReadstream 
	| serializedValue |
	
	serializedValue := aReadstream next: (self byteSize).
	
	^ serializedValue asInteger.
! !

!UnsignedIntegerCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 14:24'!
serialize

	| valueBytes start stop result |
	
	result := ByteArray new: (self byteSize).
	
	valueBytes := value asByteArray.
	start := (result size) - (valueBytes size) + 1.
	stop := (result size).
	result replaceFrom: start to: stop with: valueBytes.
	
	^ result.
! !

Object subclass: #ControllerLog
	instanceVariableNames: 'entries archive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!ControllerLog methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 16:30'!
addEntry: aControllerLogEntry 
	entries addLast: aControllerLogEntry! !

!ControllerLog methodsFor: 'recording' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 23:12'!
archive
	^ archive! !

!ControllerLog methodsFor: 'recording' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 16:21'!
archive: anEntry
	archive add: anEntry.
	entries remove: anEntry.! !

!ControllerLog methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 16:14'!
containsEntryWithSequenceNumber: aNumber 
	^ (self entryWithSequenceNumber: aNumber) isNil not.! !

!ControllerLog methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 16:12'!
entries
	^ entries! !

!ControllerLog methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 16:35'!
entryWithSequenceNumber: aNumber 
	| result |
	
	result := entries select: [ :entry | entry sequenceNumber = aNumber ].
	
	(result size = 0) ifTrue: [ ^ nil ].
	
	^ result first.! !

!ControllerLog methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 16:11'!
initialize
	entries := OrderedCollection new.
	archive := LinkedList new.! !

!ControllerLog methodsFor: 'recording' stamp: 'EmilianoMenendez 10/22/2013 12:27'!
logRequest: aRequest
	| entry sequenceNumber |

	sequenceNumber := aRequest sequenceNumber.

	(self containsEntryWithSequenceNumber: sequenceNumber) ifTrue: [
		entry := self entryWithSequenceNumber:sequenceNumber.
		self archive: entry. ].
	
	entry := ControllerLogEntry newWithRequest: aRequest.
	
	entries add: entry.
! !

!ControllerLog methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 12:28'!
logResponse: aResponse
	| logEntry sequenceNumber |
	
	sequenceNumber := aResponse sequenceNumber.

	logEntry := self entryWithSequenceNumber: sequenceNumber.

	logEntry ifNil: [
		logEntry := ControllerLogEntry new.
		self addEntry: logEntry.
	].

	logEntry response: aResponse.
! !

Object subclass: #ControllerLogEntry
	instanceVariableNames: 'sequenceNumber request response requestBytes responseBytes time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!ControllerLogEntry class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 12:29'!
newWithRequest: aCommandRequest
	^ self new initializeWithRequest: aCommandRequest! !

!ControllerLogEntry class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 20:21'!
newWithRequest: aCommandRequest andSequenceNumber: aSmallInteger 
	^ self new initializeWithRequest: aCommandRequest andSequenceNumber: aSmallInteger! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/24/2013 15:57'!
initializeWithRequest: aRequest
	request := aRequest.
	sequenceNumber := aRequest sequenceNumber.
	time := aRequest time.! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 20:42'!
request
	^ request
! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 19:54'!
requestBytes
	^ requestBytes ifNil: [ requestBytes := request serialize].! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 22:20'!
response
	^ response! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/18/2013 00:17'!
response: aResponse
	response := aResponse.! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 19:54'!
responseBytes
	^ responseBytes ifNil: [ responseBytes := response serialize].! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 16:16'!
sequenceNumber
	^ sequenceNumber! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 20:35'!
time
	^ time! !

Object subclass: #MacGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

MacGenerator subclass: #MD5MacGenerator
	instanceVariableNames: 'sequenceNumber serializedCommandCall'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!MD5MacGenerator class methodsFor: 'key' stamp: 'NahuelGarbezza 5/18/2013 09:41'!
key

	"
	'Generate a random binary key' asByteArray adding 16r00 up to 32 len
	"
	
	^ #[71 101 110 101 114 97 116 101 32 97 32 114 97 110 100 111 109 32 98 105 110 97 114 121 32 107 101 121 00 00 00 00]! !

!MD5MacGenerator methodsFor: 'initialization' stamp: 'HernanWilkinson 3/25/2013 14:54'!
initializeFor: aSerializedCommandCall with: aSequenceNumber

	serializedCommandCall := aSerializedCommandCall.
	sequenceNumber := aSequenceNumber.
! !

!MD5MacGenerator methodsFor: 'evaluating - private' stamp: 'HernanWilkinson 3/25/2013 15:36'!
macFrom: md5

	| mac |
	
	mac := md5 first: 3.
	mac swap: 1 with: 3.
	^ mac! !

!MD5MacGenerator methodsFor: 'evaluating - private' stamp: 'NahuelGarbezza 5/18/2013 09:40'!
md5For: aStream

	aStream reset.
	^ MD5 hashStream: aStream! !

!MD5MacGenerator methodsFor: 'evaluating - private' stamp: 'NahuelGarbezza 5/18/2013 09:41'!
streamToCalculateMD5

	| stream |
	stream := ReadWriteStream on: ByteArray new.
	stream
		nextPutAll: self key;
		nextPut: (sequenceNumber bitAnd: 16rFF);
		nextPut: ((sequenceNumber digitAt: 2) bitAnd: 16rFF);
		nextPut: ((sequenceNumber digitAt: 3) bitAnd: 16rFF);
		nextPut: ((sequenceNumber digitAt: 4) bitAnd: 16rFF);
		nextPutAll: serializedCommandCall.
	^ stream! !

!MD5MacGenerator methodsFor: 'evaluating' stamp: 'HernanWilkinson 3/25/2013 15:21'!
value

	| stream md5 mac |
	
	stream := self streamToCalculateMD5.
	md5 := self md5For: stream.
	mac := self macFrom: md5.
	
	^ mac
	! !

!MacGenerator class methodsFor: 'instance creation' stamp: 'NahuelGarbezza 5/18/2013 09:41'!
for: aSerializedCommandCall with: aSequenceNumber

	^ self new initializeFor: aSerializedCommandCall with: aSequenceNumber! !

!MacGenerator class methodsFor: 'key' stamp: 'HernanWilkinson 3/25/2013 14:57'!
key

	self subclassResponsibility ! !

!MacGenerator methodsFor: 'initialization' stamp: 'HernanWilkinson 3/25/2013 14:53'!
initializeFor: aSerializedCommandCall with: aSequenceNumber 

	self subclassResponsibility ! !

!MacGenerator methodsFor: 'evaluating' stamp: 'NahuelGarbezza 5/18/2013 09:40'!
key

	^ self class key! !

!MacGenerator methodsFor: 'evaluating' stamp: 'HernanWilkinson 3/25/2013 14:53'!
value

	self subclassResponsibility ! !

Object subclass: #PackageDiscardRule
	instanceVariableNames: 'name checkerBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!PackageDiscardRule class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/20/2013 14:12'!
named: aName checking: aBlock.
	^ self new initializeWithName: aName andCheckerBlock: aBlock.! !

!PackageDiscardRule class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/20/2013 14:11'!
repeatedSequenceNumber
	"TODO: improve check passing sequence number as parameter, and checking for the array #[sequence number 254]"
	^ self named: 'RepeatedSequenceNumber' checking: [ :aByteArray | (aByteArray at: 4) = 254 ].! !

!PackageDiscardRule class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/20/2013 14:11'!
wrongBeacon
	^ self named: 'WrongBeacon' checking: [ :aByteArray | (aByteArray first: 3) = #[255 255 241] ].! !

!PackageDiscardRule methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/20/2013 13:38'!
check: aByteArray
	^ checkerBlock value: aByteArray.! !

!PackageDiscardRule methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/20/2013 14:09'!
initializeWithName: aName andCheckerBlock: aBlock
	name := aName.
	checkerBlock := aBlock.! !

!PackageDiscardRule methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/20/2013 14:09'!
name
	^ name.! !

Object subclass: #RadioStreamListener
	instanceVariableNames: 'isConnected inStream radio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!RadioStreamListener class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/23/2013 16:36'!
on: aStream informing: aRadio
	^ self new initializeWithStream: aStream andRadio: aRadio! !

!RadioStreamListener methodsFor: 'control' stamp: 'EmilianoMenendez 10/23/2013 18:48'!
connect
	isConnected ifFalse: [ 
		isConnected := true.

		self log: 'connected'.
		
		self waitForPackagesFromStream.
	].
! !

!RadioStreamListener methodsFor: 'control' stamp: 'EmilianoMenendez 10/23/2013 18:48'!
disconnect
	isConnected ifTrue: [ 
		isConnected := false.

		self log: 'disconnected'.
	].
! !

!RadioStreamListener methodsFor: 'initialization' stamp: 'EmilianoMenendez 10/23/2013 18:20'!
initializeWithStream: aStream andRadio: aRadio
	inStream := aStream.
	radio := aRadio.
	isConnected := false.
! !

!RadioStreamListener methodsFor: 'accessing' stamp: 'EmilianoMenendez 10/23/2013 11:20'!
isConnected
	^ isConnected = true.

! !

!RadioStreamListener methodsFor: 'internal' stamp: 'EmilianoMenendez 10/23/2013 18:46'!
log: aMessage
	Transcript show: self class name,': ',aMessage;cr.
! !

!RadioStreamListener methodsFor: 'messaging' stamp: 'EmilianoMenendez 10/23/2013 18:46'!
readNextPackageFromStream
	| packageSize package |
	
	packageSize :=  inStream next.
	
	packageSize := (packageSize bitShift: 8) + inStream next.
	packageSize := (packageSize bitShift: 8) + inStream next.
	packageSize := (packageSize bitShift: 8) + inStream next.
	
	package := inStream next: packageSize.

	self log: 'receiving from socket ', package printString.
	
	^ package.
! !

!RadioStreamListener methodsFor: 'messaging' stamp: 'EmilianoMenendez 10/23/2013 18:53'!
sendNextPackagesToRadio
	| package |

	[inStream isDataAvailable] whileTrue: [ 
		package := self readNextPackageFromStream.
		self log: 'sending to Radio: ',package printString.		
		radio addIncomingPackage: package.
	].
! !

!RadioStreamListener methodsFor: 'control' stamp: 'EmilianoMenendez 10/23/2013 19:32'!
waitForPackagesFromStream
	self isConnected ifTrue: [ 
		self log: 'started waiting for packages'.
	].

	[[self isConnected] whileTrue: [ 
		[inStream isDataAvailable] whileFalse: [
			(Delay forSeconds: 1) wait.
		].
		self sendNextPackagesToRadio.
	]] fork.
! !

Object subclass: #Satellite
	instanceVariableNames: 'radio subsystems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!Satellite class methodsFor: 'instance creation' stamp: 'EmilianoMenendez 9/7/2013 16:27'!
newWithSubsystems: theSubsystems 
	^ self new initalizeWithSubsystems: theSubsystems! !

!Satellite methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/13/2013 14:45'!
commandWithId: aCommandId andSubsystemId: aSubsystemId
	| subsystem |
	
	subsystem := self subsystemWithId: aSubsystemId.
	
	aCommandId = 0 ifTrue: [ ^Command getNameCommand. ].
! !

!Satellite methodsFor: 'messaging' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 13:02'!
emitBeacon
	^ Beacon newFromSubsystems: subsystems.
! !

!Satellite methodsFor: 'messaging' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 15:13'!
emitShortBeacon
	^ ShortBeacon newFromSubsystems: subsystems.

	
	! !

!Satellite methodsFor: 'initialization' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 16:11'!
initalizeWithSubsystems: theSubsystems

	subsystems := theSubsystems.


! !

!Satellite methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/19/2013 17:30'!
radio: aRadio 
	radio := aRadio! !

!Satellite methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/19/2013 12:22'!
receive: aByteArray 
	| readStream sequence subsystemId commandId command subsystem response |
	
	readStream := ReadStream on: aByteArray.

	"discard MAC"
	readStream next: 3.
	
	sequence := (readStream next: 3) asInteger.
	subsystemId := readStream next asInteger.
	commandId := readStream next asInteger.
	
	command := self commandWithId: commandId andSubsystemId: subsystemId.
	
	"TODO: read parameters from stream and set them into the command"

	subsystem := self subsystemWithId: subsystemId.
	
	response := command executeOn: subsystem.
	"TODO: make part of response construction"
	response sequenceNumber: sequence.

	"send response to radio"
	self send: response serialize.

	^ response.! !

!Satellite methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/24/2013 12:21'!
send: aByteArray 
	radio sendToController: aByteArray.! !

!Satellite methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 17:23'!
subsystemWithId: aSubsystemId
	^ subsystems detect: [ :subsystem | subsystem id = aSubsystemId ].
! !

!Satellite methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/9/2013 19:59'!
subsystems
	
	^ subsystems
! !

Object subclass: #SatelliteController
	instanceVariableNames: 'radio messageCodec sequenceNumberGenerator log packageDiscardRules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!SatelliteController class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 10:22'!
newWith: aRadio
	^ self new initializeWith: aRadio! !

!SatelliteController methodsFor: 'initialization' stamp: 'EmilianoMenendez 10/24/2013 16:59'!
initializeWith: aRadio 
	self log: 'initializing'.

	radio := aRadio.
	radio controller: self.

	messageCodec := SatelliteControllerMessageCodec new.

	log := ControllerLog new.

	sequenceNumberGenerator := SequenceNumber new.
	
	packageDiscardRules := OrderedCollection new.
	packageDiscardRules add: PackageDiscardRule wrongBeacon.
	packageDiscardRules add: PackageDiscardRule repeatedSequenceNumber.

	self log: 'initialized'.
! !

!SatelliteController methodsFor: 'serialization' stamp: 'EmilianoMenendez 10/24/2013 16:53'!
isAcceptedPackage: aByteArray
	| failedRule |
	
	failedRule := packageDiscardRules detect: [ :rule | rule check: aByteArray. ] ifNone: [ ^ true ].
	
	self log: 'discarding ',aByteArray printString,'. Failed rule: ',failedRule name.
	
	^ false.
! !

!SatelliteController methodsFor: 'messaging' stamp: 'EmilianoMenendez 10/21/2013 19:48'!
log
	^ log! !

!SatelliteController methodsFor: 'internal' stamp: 'EmilianoMenendez 10/23/2013 21:05'!
log: aMessage
	Transcript show: self class name,': ',aMessage;cr.! !

!SatelliteController methodsFor: 'messaging' stamp: 'EmilianoMenendez 10/24/2013 16:59'!
newIncomingMessages
	| packages messages message correctPackages |
	
	messages := OrderedCollection new.
	
	packages := radio incomingPackages.
	
	correctPackages := packages select: [ :package | self isAcceptedPackage: package. ].
	
	correctPackages do: [ :package | 
		message := messageCodec deserialize: package.
		messages add: message.
		log logResponse: message.
	].

	^ messages.
! !

!SatelliteController methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/24/2013 16:59'!
receive: aByteArray 
	| message |
	
	(self isAcceptedPackage: aByteArray) ifTrue: [ 
		message := messageCodec deserialize: aByteArray.
		log logResponse: message.
	].		
! !

!SatelliteController methodsFor: 'messaging' stamp: 'EmilianoMenendez 10/24/2013 16:59'!
registerRequest: aCommandRequest forCommand: aCommandDefinition

	messageCodec registerCommandDefinition: aCommandDefinition forSequenceNumber: aCommandRequest sequenceNumber.
	
	log logRequest: aCommandRequest.! !

!SatelliteController methodsFor: 'messaging' stamp: 'EmilianoMenendez 10/24/2013 17:00'!
sendCommand: aCommandDefinition toSubsystem: aSubsystem withData: aData
	| serializedMessage sequenceNumber request |
	
	sequenceNumber := sequenceNumberGenerator next.
	
	request := CommandRequest for: aCommandDefinition andSubsystem: aSubsystem withSequenceNumber: sequenceNumber andData: aData.

	self registerRequest: request forCommand: aCommandDefinition.
	
	serializedMessage := messageCodec serializeRequest: request.
	
	radio sendToSatellite: serializedMessage.
	
	^ sequenceNumber.
! !

!SatelliteController methodsFor: 'control' stamp: 'EmilianoMenendez 10/23/2013 21:14'!
shutdown
	self log: 'shutting down'.

	radio disconnect.

	self log: 'shutdown finished'.
! !

Object subclass: #SatelliteControllerApp
	instanceVariableNames: 'satelliteController launcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!SatelliteControllerApp methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/22/2013 20:02'!
send: aCommand to: aSubsystem with: data

	satelliteController sendCommand:  aCommand toSubsystem: aSubsystem  withData: data! !

!SatelliteControllerApp methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/22/2013 19:31'!
shutDown

| radio controlador |

radio := ReadStream new.
controlador := SatelliteController newWith: radio.

DAOSatelliteControllerLauncher new startApp.! !

!SatelliteControllerApp methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/23/2013 20:47'!
startUp

| radio |

radio := SatelliteControllerRadioWithStreamListener new.
satelliteController := SatelliteController newWith: radio.
launcher := DAOSatelliteControllerLauncher new.

launcher startApp.

! !

Object subclass: #SatelliteControllerMessageCodec
	instanceVariableNames: 'commandDefinitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!SatelliteControllerMessageCodec methodsFor: 'deserialization' stamp: 'EmilianoMenendez 10/24/2013 16:12'!
deserialize: aByteArray
	| sequenceNumber messageDefinition data stream |

	data := OrderedCollection new.
	
	sequenceNumber := (aByteArray first: 3) asInteger.
	
	stream := ReadStream on: (aByteArray allButFirst: 3).
	
	messageDefinition := (commandDefinitions at: sequenceNumber) responseDefinition.
	
	messageDefinition do: [ :parameter | data add: (Association key: (parameter name) value: (parameter deserialize: stream)) ].
	
	^ DataCommandResponse for: messageDefinition withSequenceNumber: sequenceNumber andData: data.
! !

!SatelliteControllerMessageCodec methodsFor: 'deserialization' stamp: 'EmilianoMenendez 10/24/2013 16:44'!
initialize
	| beaconDefinition shortBeaconDefinition |
	
	commandDefinitions := Dictionary new.

	beaconDefinition := BeaconDefinition new.
	commandDefinitions at: ((beaconDefinition id) asInteger) put: beaconDefinition.
	shortBeaconDefinition := ShortBeaconDefinition new.
	commandDefinitions at: ((shortBeaconDefinition id) asInteger) put: shortBeaconDefinition.
! !

!SatelliteControllerMessageCodec methodsFor: 'internal' stamp: 'EmilianoMenendez 10/24/2013 16:09'!
log: aMessage
	Transcript show: self class name,': ',aMessage;cr.! !

!SatelliteControllerMessageCodec methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/24/2013 16:48'!
registerCommandDefinition: aCommandDefinition forSequenceNumber: sequenceNumber 
	commandDefinitions at: sequenceNumber put: aCommandDefinition.
! !

!SatelliteControllerMessageCodec methodsFor: 'serialization' stamp: 'EmilianoMenendez 10/24/2013 16:09'!
serializeCommandFromRequest: aCommandRequest
	| stream |

	stream := WriteStream on: ByteArray new.

	stream nextPut: aCommandRequest subsystem id asByte.
	stream nextPutAll: aCommandRequest serialize.
	
	^ stream contents.
! !

!SatelliteControllerMessageCodec methodsFor: 'serialization' stamp: 'EmilianoMenendez 10/24/2013 16:09'!
serializeRequest: aCommandRequest
	| sequenceNumber stream serializedCommand serializedSequenceNumber macGenerator |

	stream := WriteStream on: ByteArray new.	

	sequenceNumber := aCommandRequest sequenceNumber.

	serializedCommand := self serializeCommandFromRequest: aCommandRequest.
	
	macGenerator := MD5MacGenerator for: serializedCommand with: sequenceNumber.
	
	stream nextPutAll: macGenerator value asByteArray.
	
	serializedSequenceNumber := self serializeSequenceNumber: sequenceNumber.
	
	stream nextPutAll: serializedSequenceNumber.
	
	stream nextPutAll: serializedCommand.
	
	^ stream contents
! !

!SatelliteControllerMessageCodec methodsFor: 'serialization' stamp: 'EmilianoMenendez 10/24/2013 16:09'!
serializeSequenceNumber: aSequenceNumber
	| sequenceNumberParameter |
	
	sequenceNumberParameter := UnsignedIntegerCommandParameter new: 24.
	sequenceNumberParameter value: aSequenceNumber.
	
	^ sequenceNumberParameter serialize.
! !

Object subclass: #SatelliteControllerRadio
	instanceVariableNames: 'host port stream controller incomingPackageSemaphore incomingPackages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!SatelliteControllerRadio class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/19/2013 15:52'!
connectTo: aHost port: aPort
	^ self new initializeWithHost: aHost andPort: aPort.
! !

!SatelliteControllerRadio methodsFor: 'accessing' stamp: 'EmilianoMenendez 10/23/2013 20:29'!
addIncomingPackage: aPackage

	self log: 'incoming package ',aPackage printString.

	incomingPackages add: aPackage.

! !

!SatelliteControllerRadio methodsFor: 'control' stamp: 'EmilianoMenendez 10/23/2013 21:19'!
connect

	self log: 'opening stream'.
	stream := SocketStream openConnectionToHost: host port: port.
	stream binary.

	self listenForIncomingPackages.
! !

!SatelliteControllerRadio methodsFor: 'messaging' stamp: 'EmilianoMenendez 10/24/2013 12:26'!
controller: aSatelliteController
	controller := aSatelliteController! !

!SatelliteControllerRadio methodsFor: 'control' stamp: 'EmilianoMenendez 10/23/2013 21:18'!
disconnect
	self log: 'shutting down'.

	stream close.

	self log: 'shutdown finished'.

! !

!SatelliteControllerRadio methodsFor: 'accessing' stamp: 'EmilianoMenendez 10/24/2013 13:38'!
incomingPackages
	incomingPackages ifEmpty: [incomingPackageSemaphore wait].
	^ incomingPackages removeFirst: (incomingPackages size).
! !

!SatelliteControllerRadio methodsFor: 'initialization' stamp: 'EmilianoMenendez 10/23/2013 20:39'!
initializeWithHost: aHost andPort: aPort.
	incomingPackages := OrderedCollection new.
	incomingPackageSemaphore := Semaphore new.
	host := aHost.
	port := aPort.
	self connect.! !

!SatelliteControllerRadio methodsFor: 'control' stamp: 'EmilianoMenendez 10/23/2013 21:19'!
listenForIncomingPackages
	self log: 'listening for packages'.

	[[[stream isConnected] whileTrue: [ 
		[stream isDataAvailable] whileFalse: [
			(Delay forSeconds: 1) wait.
		].
		self readNextPackagesFromStream.
	]] ensure: [ incomingPackageSemaphore signal ]] fork.
! !

!SatelliteControllerRadio methodsFor: 'internal' stamp: 'EmilianoMenendez 10/23/2013 20:20'!
log: aMessage
	Transcript show: self class name,': ',aMessage;cr.! !

!SatelliteControllerRadio methodsFor: 'messaging' stamp: 'EmilianoMenendez 10/23/2013 20:40'!
readNextPackageFromStream
	| packageSize package |
	
	packageSize :=  stream next.
	
	packageSize := (packageSize bitShift: 8) +stream next.
	packageSize := (packageSize bitShift: 8) + stream next.
	packageSize := (packageSize bitShift: 8) +stream next.
	
	package := stream next: packageSize.
	
	^ package.! !

!SatelliteControllerRadio methodsFor: 'messaging' stamp: 'EmilianoMenendez 10/23/2013 20:40'!
readNextPackagesFromStream
	| package |

	[stream isDataAvailable] whileTrue: [ 
		package := self readNextPackageFromStream.		
		self addIncomingPackage: package.
	].

	incomingPackageSemaphore signal.
! !

!SatelliteControllerRadio methodsFor: 'messaging' stamp: 'EmilianoMenendez 10/24/2013 12:26'!
sendToController: aByteArray 
	controller receive: aByteArray! !

!SatelliteControllerRadio methodsFor: 'messaging' stamp: 'EmilianoMenendez 10/23/2013 20:20'!
sendToSatellite: aByteArray
	self log: 'sending ',aByteArray printString.
	stream nextPutAll: aByteArray.
	stream flush.! !

Object subclass: #SatelliteControllerRadioWithStreamListener
	instanceVariableNames: 'host port stream streamListener incomingPackageSemaphore incomingPackages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!SatelliteControllerRadioWithStreamListener class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/19/2013 15:52'!
connectTo: aHost port: aPort
	^ self new initializeWithHost: aHost andPort: aPort.
! !

!SatelliteControllerRadioWithStreamListener methodsFor: 'messaging' stamp: 'EmilianoMenendez 10/23/2013 19:22'!
addIncomingPackage: aPackage

	self log: 'incoming package ',aPackage printString.

	incomingPackages add: aPackage.

	incomingPackageSemaphore signal.
! !

!SatelliteControllerRadioWithStreamListener methodsFor: 'control' stamp: 'EmilianoMenendez 10/23/2013 20:19'!
connect
	stream ifNil: [ 
		stream := SocketStream openConnectionToHost: host port: port.
		stream binary.

		streamListener := RadioStreamListener on: stream informing: self.

		streamListener connect.
	].

	self waitForIncomingPackages.
! !

!SatelliteControllerRadioWithStreamListener methodsFor: 'control' stamp: 'EmilianoMenendez 10/23/2013 20:05'!
disconnect
	streamListener ifNotNil: [ 
		streamListener disconnect.
	].

	stream close.
	stream := nil.
! !

!SatelliteControllerRadioWithStreamListener methodsFor: 'messaging' stamp: 'EmilianoMenendez 10/24/2013 13:38'!
incomingPackages
	incomingPackages ifEmpty: [incomingPackageSemaphore wait].
	^ incomingPackages removeFirst: (incomingPackages size).
! !

!SatelliteControllerRadioWithStreamListener methodsFor: 'initialization' stamp: 'EmilianoMenendez 10/23/2013 19:25'!
initialize
	incomingPackages := OrderedCollection new.
	incomingPackageSemaphore := Semaphore new.! !

!SatelliteControllerRadioWithStreamListener methodsFor: 'initialization' stamp: 'EmilianoMenendez 10/23/2013 16:52'!
initializeWithHost: aHost andPort: aPort.
	self initialize.
	host := aHost.
	port := aPort.
	self connect.! !

!SatelliteControllerRadioWithStreamListener methodsFor: 'internal' stamp: 'EmilianoMenendez 10/23/2013 18:50'!
log: aMessage
	Transcript show: self class name,': ',aMessage;cr.! !

!SatelliteControllerRadioWithStreamListener methodsFor: 'messaging' stamp: 'EmilianoMenendez 10/23/2013 18:51'!
sendToSatellite: aByteArray
	self log: 'sending ',aByteArray printString.
	stream nextPutAll: aByteArray.
	stream flush.! !

!SatelliteControllerRadioWithStreamListener methodsFor: 'messaging' stamp: 'EmilianoMenendez 10/23/2013 19:22'!
waitForIncomingPackages
	incomingPackageSemaphore wait.! !

Object subclass: #SequenceNumber
	instanceVariableNames: 'number lastNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

SequenceNumber class
	instanceVariableNames: 'number'!

SequenceNumber class
	instanceVariableNames: 'number'!

!SequenceNumber class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/20/2013 17:36'!
startingFrom: aNumber
	^ self new initializeWithStart: aNumber! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 19:08'!
asByteArray
	| resultSize resultBytes sequenceNumber start |

	resultSize := 3.

	resultBytes := ByteArray new: resultSize.
	
	sequenceNumber := number asByteArray.

	start := (resultSize - (sequenceNumber size) + 1).

	^ resultBytes replaceFrom: start to: resultSize with: sequenceNumber. 
! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/27/2013 12:55'!
bitAnd: aSmallInteger 
	^number bitAnd: aSmallInteger ! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/19/2013 15:13'!
current
	^ number! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/27/2013 12:56'!
digitAt: aSmallInteger 
	^number bitAnd: aSmallInteger ! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/20/2013 10:56'!
initialize
	number := 0.
	lastNumber := LargePositiveInteger readFrom: 'FFFFEF' base: 16.
! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 14:58'!
initializeWithStart: aNumber
	self initialize.
	number := aNumber.! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 14:53'!
next
	number := number + 1.
	number > lastNumber ifTrue: [ self reset. ].
	^ number.
! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 14:52'!
reset
	number := 1.! !

Object subclass: #Subsystem
	instanceVariableNames: 'id data telemetryKeys shortTelemetryKeys name commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!Subsystem class methodsFor: 'instantiation' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/17/2013 15:42'!
cdh
	| shortTkeys tKeys cmds |
	
	tKeys := OrderedCollection new.
	tKeys add: 'lastSeenSequenceNumber'.
	tKeys add: 'nextBeaconEnableTicks'.
	tKeys add: 'antennaDeployStatus'.
	
	shortTkeys := OrderedCollection new.
	shortTkeys add: 'ticksLow'.
	
	cmds:= Dictionary new.
	cmds at: 'name' put: Command getNameCommand .
	cmds at: 'telemetry' put: Command cdhTelemetry.
	cmds at: 'short_telemetry' put: Command cdhShortTelemetry.
	cmds at: 'delay_beaconSeconds' put: Command cdhDelayBeacon.
	cmds at: 'set_beacon_intervalSeconds' put: Command cdhSetBeaconInterval.
	cmds at: 'set_tx_powerr' put: Command cdhSet_tx_power.
	cmds at: 'set_beaconData' put: Command cdhSetBeaconData.
	cmds at: 'get_radio' put: Command cdhGetRadio.
	cmds at: 'set_radioConfig' put: Command cdhSetRadio.
	

	^self new initializeWithId: 4 andName: 'CDH' andTelemetryKeys: tKeys andShortTelemetryKeys: shortTkeys andCommands: Dictionary new.
! !

!Subsystem class methodsFor: 'instantiation' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/17/2013 15:42'!
memory
	
	|tKeys shortTKeys cmds |
	
	tKeys := OrderedCollection new.
	tKeys add: 'free'.
	
	shortTKeys := OrderedCollection new.

	cmds := Dictionary new.
	cmds at: 'name' put: Command getNameCommand.
	cmds at: 'telemetry' put: Command memoryTelemetry.
	cmds at: 'short_telemetry' put: Command memoryShortTelemetry.
	cmds at: 'readAdress' put: Command memoryReadAddress.
	
 	^self new initializeWithId: 1 andName: 'MEMORY' andTelemetryKeys: tKeys andShortTelemetryKeys: shortTKeys andCommands: cmds.! !

!Subsystem class methodsFor: 'instantiation' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/17/2013 15:42'!
platform

	| tKeys shortTKeys cmds |
	
	tKeys := OrderedCollection new.
	tKeys add: 'tickCount'.
	tKeys add: 'currentMode'.
	
	shortTKeys := OrderedCollection new.
	
	cmds:= Dictionary new.
	cmds at: 'name' put: Command getNameCommand.
	cmds at: 'telemetry' put: Command platformTelemetry.
	cmds at: 'short_telemetry' put: Command platformShortTelemetry.
	cmds at: 'setMode' put: Command platformSetMode.
	cmds at: 'reset' put: Command platformReset.
	cmds at: 'version' put: Command platformVersion.
	
	^self new initializeWithId: 0 andName: 'PLATFORM' andTelemetryKeys: tKeys andShortTelemetryKeys: shortTKeys andCommands: cmds.! !

!Subsystem class methodsFor: 'instantiation' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/17/2013 15:42'!
power

	| tKeys shortTKeys cmds |
	
	tKeys := OrderedCollection new.
	tKeys add: 'low_voltage_counter'.
	tKeys add: 'battery_v'.
	tKeys add: 'array_X_v'.
	tKeys add: 'array_Xp_mA'.
	tKeys add: 'array_Xm_mA'.
	tKeys add: 'array_Y_v'.
	tKeys add: 'array_Yp_mA'.
	tKeys add: 'array_Y_mA'.
	tKeys add: 'array_Z_v'.
	tKeys add: 'array_Zp_mA'.
	tKeys add: 'array_Zm_mA'.
	tKeys add: '_3v3_mA'.
	tKeys add: '_5v_mA'.
	
	shortTKeys := OrderedCollection new.
	
	cmds:= Dictionary new.
	cmds at: 'name' put: Command getNameCommand.
	cmds at: 'telemetry' put: Command powerTelemetry.
	cmds at: 'short_telemetry' put: Command powerShortTelemetry.
	cmds at: 'stbGetSwitchesState' put: Command powerStbGetSwitchesState.
	cmds at: 'reset' put: Command powerReset.
	cmds at: 'stbGetSwitches' put: Command powerStbSetSwitchesState.
	cmds at: 'stbSetInitialState' put: Command powerStbSetInitialState.
	
	^self new initializeWithId: 2 andName: 'POWER' andTelemetryKeys: tKeys andShortTelemetryKeys: shortTKeys andCommands: cmds.! !

!Subsystem class methodsFor: 'instantiation' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/17/2013 15:42'!
thermal

	| cmds shortTkeys tKeys |
	
	tKeys := OrderedCollection new.
	tKeys add: 'battery_temp'.
	tKeys add: 'radio_temp'.
	
	shortTkeys := OrderedCollection new.
	shortTkeys add: 'battery_temp'.
	
	cmds := Dictionary new.
	cmds at: 'name' put: Command getNameCommand.
	cmds at: 'telemetry' put: Command thermalTelemetry.
	cmds at: 'short_telemetry' put: Command thermalShortTelemetry.
	cmds at: 'setMatrixKey' put: Command thermalSetMatrixKey.
	
	
	^self new initializeWithId: 3 andName: 'THERMAL' andTelemetryKeys: tKeys andShortTelemetryKeys: shortTkeys andCommands: cmds.
	
! !

!Subsystem methodsFor: 'command' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/14/2013 16:35'!
= anObject
	^ id = anObject id! !

!Subsystem methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/9/2013 18:27'!
commands
	^ commands! !

!Subsystem methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/14/2013 16:03'!
getValueOfAttribute: aKey
	^ (data at: aKey)! !

!Subsystem methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/9/2013 16:10'!
id
	^ id! !

!Subsystem methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/28/2013 21:27'!
initializeWithId: theId andName: theName andTelemetryKeys: theTelemetryKeys andShortTelemetryKeys: theShortTelemetryKeys andCommands: theCommands
	id := theId.
	name := theName.
	commands := theCommands.
	telemetryKeys := theTelemetryKeys.
	shortTelemetryKeys := theShortTelemetryKeys.
	data := Dictionary new.! !

!Subsystem methodsFor: 'command' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/9/2013 16:11'!
name
	^ name! !

!Subsystem methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/14/2013 12:46'!
setAttribute: aKey withValue: aValue 
	data at: aKey put: aValue! !

!Subsystem methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/2/2013 16:05'!
setMatrixKey: theValue
	data at: 'matrix_key' put: theValue! !

!Subsystem methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/2/2013 16:05'!
setMode: theValue
	data at: 'current_mode' put: theValue! !

!Subsystem methodsFor: 'command' stamp: 'EmilianoMenendez 10/22/2013 15:32'!
shortTelemetry
	| result |
	
	result := OrderedCollection new.
	
	shortTelemetryKeys do: [ :key | result add: (data associationAt: key)].
	
	"TODO: add definition"
	^ DataCommandResponse for: nil withSequenceNumber: 0 andData: result
	
	
	
	! !

!Subsystem methodsFor: 'command' stamp: 'EmilianoMenendez 10/22/2013 15:32'!
telemetry
	| result |
	
	result := OrderedCollection new.
	
	telemetryKeys do: [ :key | result add: (data associationAt: key)].
	
	"TODO: add definition"
	^ DataCommandResponse for: nil withSequenceNumber: 0 andData: result! !

!Subsystem methodsFor: 'accessing' stamp: 'EzequielDavidovichCaballero 9/29/2013 17:30'!
understands: aCommand
	^ (commands keys includes: aCommand).! !
SatelliteControlWebApp initialize!
